package com.blazinggames.cqfs.converse
{
	/**
	 * The standard list of constants that the various converse classes use.
	 * This is a separate entry due to the simple fact that variables, including
	 * constants, are not allowed in interfaces (the logical place to place 
	 * these) so instead I am putting them all in one class that the other 
	 * classes can reference. 
	 *
	 * @author Billy D. Spelchan
	 * @version 1.0
	 * Copyright (c) 2007 Blazing Games Inc. All Rights Reserved.
	*/
	public class Converse
	{
// *********************
// ***** CONSTANTS *****
// *********************

		public static const DIALOGTYPE_DESCRIPTION:int = 0;
		public static const DIALOGTYPE_SPEACH:int = 1;
		public static const DIALOGTYPE_THOUGHT:int = 2;
		public static const DIALOGTYPE_EXCLAMATION:int = 3;
		public static const DIALOGTYPE_WHISPER:int = 4;
		public static const DIALOGTYPE_ROBOTIC:int = 5;

		public static const DIALOG_LABELS:Array = new Array(
				"description", "speach", "thought", "exclamation", 
				"whisper", "robotic"
		);
		public static const DIALOG_SHOWN_EVENT:String = "DIALOG_SHOWN_EVENT";
		public static const RESPONSE_SHOWN_EVENT:String= "RESPONSE_SHOWN_EVENT";
		public static const SPEACH_EVENT:String = "CONVERSE_SPEACH_EVENT";
		public static const TOPIC_EVENT:String = "CONVERSE_TOPIC_EVENT";
	} // end class
} // end package

