package com.blazinggames.ootw.ep34
{
	// Adobe Imports
	import flash.display.MovieClip;
	import flash.display.SimpleButton;
	import flash.events.Event;
	import flash.events.MouseEvent;

	// Blazing Games imports
	import com.blazinggames.cqfs.converse.*;

	/**
	 *
	 * @author Billy D. Spelchan
	 * @version 1.0
	 * Copyright (c) 2008 Blazing Games Inc. All Rights Reserved.
	*/
	public class OotW34Conversation
	extends MovieClip
	{
// ***** CONSTANTS **********************************************************

// ***** VARIABLES **********************************************************

		protected var _scriptHandler:DefaultScriptCommand;
		protected var _conversation:ConversationHandler;
		protected var _owner:OotW34;

// ***** CONSTRUCTOR ********************************************************

		public function OotW34Conversation()
		{
			_scriptHandler = new DefaultScriptCommand(true);
			_conversation = new ConversationHandler(speach_movie, _scriptHandler);
			speach_movie.clearDisplay();
			_conversation.addEventListener(Converse.TOPIC_EVENT, topicHandler);
			
			// create the conversation tree.
			var fs:String = "ISFLAGSET TRUE";
			_conversation.addTopic( ConversationHandler.EXIT_TOPIC);

			// Starting and Ending conversation
			_conversation.addTopic( new ConversationTopic(
					"StartEp", "Start game", "We better get into the ship quickly before they realize what is going on.", 
					5,1, fs, null, new Array("Continue")));
			_conversation.addTopic( new ConversationTopic(
					"Continue", "Well, I guess we better get on board...", "should go to ship",
					5,1, fs, null, new Array("Exit")));
			_conversation.addTopic( new ConversationTopic(
					"Over", "The End!", "Game over",
					5,1, fs, null, new Array("Exit")));
			_conversation.addTopic( new ConversationTopic(
					"Win", "To be coninued April 2008...", "Game over",
					5,1, fs, null, new Array("Exit")));
			_conversation.addTopic( new ConversationTopic(
					"ParkEnd", "The End!", "I guess the week has been hectic enough for you. If you had decided to come with me, I am sure that things would have ended up even more twisted than you expected.",
					5,1, fs, null, new Array("Over")));
			_conversation.addTopic( new ConversationTopic(
					"SpaceEnd", "To be coninued April 2008...", "It's late and it will be hours before we are ready to use the moon as a slingshot so you had best get some rest.",
					5,1, fs, null, new Array("Win")));

			// Squirrel conversation
			_conversation.addTopic( new ConversationTopic(
					"Squirrel", "Talk to Squirrel", "Squirrel am I. No name given have I been. Important names are. Myself will name I. hmmmm. Chuck!", 
					2,1, fs, null, new Array("sqPuck", "sqCharles", "sqNut", "sqYkcul", "Exit")));
			_conversation.addTopic( new ConversationTopic(
					"sqPuck", "What's the deal with Mr. Puck?", "Shiny puck not. Tasty puck not. Ykcul like puck why not sure. For Ykcul get puck.", 
					2,1, fs, null, new Array("sqCharles", "sqNut", "sqYkcul", "Exit")));
			_conversation.addTopic( new ConversationTopic(
					"sqNut", "Why the obsession with Nuts?", "Nuts tasty. Life, energy do nuts give.",
					2,1, fs, null, new Array("sqPuck", "sqCharles", "sqYkcul", "Exit")));
			_conversation.addTopic( new ConversationTopic(
					"sqCharles", "Why do you hate Charles?", "Hate not Charles until nuts did Charles steal. Ruined did he good storage spot!", 
					2,1, fs, null, new Array("sqPuck", "sqNut", "sqYkcul", "Exit")));
			_conversation.addTopic( new ConversationTopic(
					"sqYkcul", "You know Ykcul?", "Make nuts can Ykcul's ship.", 
					2,1, fs, null, new Array("sqPuck", "sqCharles", "sqNut", "Exit")));
			
			// Ykcul conversation
			_conversation.addTopic( new ConversationTopic(
					"Ykcul", "Talk to Ykcul", "My name is Ykcul. I am sure you have a lot of questions on your mind, and you certainly do have a decision to make.", 
					5,1, fs, null, new Array("yWhat", "yHere", "yMe", "Exit")));
			_conversation.addTopic( new ConversationTopic(
					"yWhat", "What exactly are you?", "I am a Cantriever, and am obviously from another world. My resemblance to the creatures you call dogs is purely a coincidence. I came here after the Gorbons attacked my home world.", 
					5,1, fs, null, new Array("yHere", "yMe", "Cantriever", "Gorbon", "Exit")));
			_conversation.addTopic( new ConversationTopic(
					"Cantriever", "A Cantriever?", "Cantrievers are a peaceful race, who were trying to form a collective of intelligent races to better promote peace across the galaxy. The Gorbon sneak attack has hindered our efforts. The survivors of that attack have all fled to our various colonies.", 
					5,1, fs, null, new Array("yHere", "yMe", "Gorbon", "Exit")));
			_conversation.addTopic( new ConversationTopic(
					"Gorbon", "You mean that Gorbons are real?", "Gorbons are a former biological species that turned themselves into machines. Thankfully they are still using sub-factorial propulsion so it takes them many years to travel between stars.", 
					5,1, fs, null, new Array("yHere", "yMe", "Cantriever", "Exit")));
			_conversation.addTopic( new ConversationTopic(
					"yHere", "How did you end up here?", "I was actually heading for one of the Cantriever research colonies, but I am an engineer not a navigator so I ended up crashing into your planet where I was taken prisoner.", 
					5,1, fs, null, new Array("yWhat", "yMe", "Crashed", "Speed", "yPuck", "yCharles", "Exit")));
			_conversation.addTopic( new ConversationTopic(
					"Crashed", "Isn't crashing into a planet hard to do?", "Like I told you, I am an engineer not a navigator. Yes, there is a vast amount of empty space between planets and stars and accidentally running into one is extremely improbable, but when you drop out of factorial right in front of a planet it is hard to maneuver quick enough to get out of the gravity well. ", 
					5,1, fs, null, new Array("yWhat", "yMe", "Speed", "yPuck", "yCharles", "Exit")));
			_conversation.addTopic( new ConversationTopic(
					"Speed", "How fast can your ship go?", "We have drives that use gravity to distort space. This distortion allows us to effectively shrink the size of space, which has the effect of letting us travel vast distances in short periods of time. The distortion effect is measured in factorials, with 1 being the speed of light. This ship can reach 7 factorial!", 
					5,1, fs, null, new Array("yWhat", "yMe", "Crashed", "yPuck", "yCharles", "Exit")));
			_conversation.addTopic( new ConversationTopic(
					"yPuck", "What's the deal with the Puck?", "Mr. Puck is human technology that Charles created. It is some type of holographic storage system used to create locks of near impossibility to break into without a key.", 
					5,1, fs, null, new Array("yWhat", "yMe", "Crashed", "Speed", "yCharles", "Exit")));
			_conversation.addTopic( new ConversationTopic(
					"yCharles", "How did Charles get involved in this?", "You would have to ask Charles about how he knew about this ship to find that out.", 
					5,1, fs, null, new Array("yWhat", "yMe", "Crashed", "Speed", "yPuck", "Exit")));
			_conversation.addTopic( new ConversationTopic(
					"yMe", "What's going to happen to me now?", "That is a decision that you are going to have to make. Do you wish me to drop you off in your city, or do you want to join me in an out of this world adventure?", 
					5,1, fs, null, new Array("Home", "Space", "Exit")));
			_conversation.addTopic( new ConversationTopic(
					"Home", "Going Home would be my choice", "Home should cut to ending", 
					5,1, fs, null, new Array( "Exit")));
			_conversation.addTopic( new ConversationTopic(
					"Space", "I'll join you!", "Space should cut to ending", 
					5,1, fs, null, new Array("Exit")));

			// Charles conversation
			_conversation.addTopic( new ConversationTopic(
					"Charles", "Talk to Charles", "This is exciting, isn't it. I'm glad I decided to come with you back to the mainland!", 
					5,1, fs, null, new Array("cKnow", "cGoing", "cMemory", "Exit")));
			_conversation.addTopic( new ConversationTopic(
					"cKnow", "How did you know about the ship?", "Gartony has government insiders who found out about the crash the day it happened and he made arrangements to make sure that my company would be installing the locks in the secret hanger.", 
					5,1, fs, null, new Array("cGoing", "cGartony", "cHanger", "cJack", "cCrash", "cMemory", "Exit")));
			_conversation.addTopic( new ConversationTopic(
					"cGartony", "You worked for Gartony?", "Of course I secretly worked for Gartony. How else do you think a poor person would get money to start such a large company. He wants to get out of organized crime, and thought that technology companies would be the best way to go legit.", 
					5,1, fs, null, new Array("cGoing", "cHanger", "cJack", "cCrash", "cMemory", "Exit")));
			_conversation.addTopic( new ConversationTopic(
					"cHanger", "How did you know about the Hanger?", "We were developing holographic storage for general use, but due to it's properties it is very easy to hide information within the hologram, and very hard to find that information if you don't know where to look. That's why Mr. Puck is the key.", 
					5,1, fs, null, new Array("cGoing", "cGartony", "cJack", "cCrash", "cMemory", "Exit")));
			_conversation.addTopic( new ConversationTopic(
					"cJack", "You worked with Jack?", "Well, Jack definitely has some influence on project Xeno, but I thankfully never met him. If you are lucky you will never meet him either. Oh, you have. Sorry.", 
					5,1, fs, null, new Array("cGoing", "cGartony", "cHanger", "cCrash", "cMemory", "Exit")));
			_conversation.addTopic( new ConversationTopic(
					"cCrash", "Do you know why your plane crashed?", "I thought it was poor luck that caused engine failure, but now I suspect Jack didn't want me reporting things back to Gartony.", 
					5,1, fs, null, new Array("cGoing", "cGartony", "cHanger", "cJack", "cMemory", "Exit")));
			_conversation.addTopic( new ConversationTopic(
					"cGoing", "Are you going to stay with Ykcul", "Of course I'm going. I've always wanted to travel to other stars. Why else would I invest research money in self-sustaining habitats?", 
					5,1, fs, null, new Array("cKnow", "cMemory", "Exit")));
			_conversation.addTopic( new ConversationTopic(
					"cMemory", "How is your memory doing", "Bits of it are coming back, but I might be better off not remembering my past.", 
					5,1, fs, null, new Array("cKnow", "cGoing", "Exit")));
			
		}

// *****

		function topicHandler(event:Event):void {
			var top:ConversationTopic = _conversation.getLastTopic();
			trace(top.topic + "topic was selected");

			if ((top.topic == "Exit") || (top.topic == "Continue")) {
				_owner.toInside();
			} else if (top.topic == "Home") {
				_owner.toPark();
			} else if (top.topic == "Space") {
				_owner.toSpace();
			} else if ((top.topic == "Over") || (top.topic == "Win")) {
				_owner.endGame();
			} else {
				_conversation.showTopic(top.topic);
			}
		}

// ***** Functions - General control ****************************************

		public function showTopic(s:String, owner:OotW34)
		{
			_conversation.showTopic(s);
			_owner = owner;
		}
	} // end class
} // end package
